
#include <linux/module.h>
#include <linux/init.h>
#include <linux/pci.h>


struct pci_device_id galil1800_idtable[] = {
	{  .vendor = 0x10B5,
	   .device = 0x9050,
	   .subvendor = 0x1079,
	   .subdevice = 0x1800,
	   .class = 0,
	   .class_mask = 0,
	   .driver_data = 0 },
	{ 0, }
};

struct pci_driver galil1800_driver  = {
	.name = "galil1800",
	.id_table = galil1800_idtable,
	.probe = NULL,
	.remove = NULL,
	.suspend = NULL,
	.resume = NULL,
	.enable_wake = NULL,
	.shutdown = NULL
};


MODULE_AUTHOR("Universit di Roma Tor Vergata (E. Betti)");
MODULE_DESCRIPTION("Galil DMC 1800 Example Driver for Free Course"
			" of Linux Kernel Hacking 2006");
MODULE_VERSION("0.1");
MODULE_ALIAS("galil1800");
MODULE_LICENSE("GPL");


/* init module function */
int __init galil1800_init(void)
{
	int rc = pci_register_driver(&galil1800_driver);
	if (rc) {
		printk(KERN_ERR	"Galil 1800: cannot register"
			" the PCI device driver\n");
		return rc;
	}
	printk(KERN_DEBUG "Galil 1800: module loaded\n");
	return 0;
}

/* cleanup module function */
void __exit galil1800_cleanup(void)
{
	pci_unregister_driver(&galil1800_driver);
	printk(KERN_DEBUG "Galil 1800: module unloaded\n");
}

module_init(galil1800_init);
module_exit(galil1800_cleanup);
